/* socks-gw.h */
/*
	RcsId[] = "$Header: /usr/home/ygk/fwtk/socks-gw/RCS/socks-gw.h,v 1.1 2000/05/22 15:10:19 ygk Exp ygk $;
*/

#include	<syslog.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<sys/file.h>
#include	<sys/time.h>
#include	<sys/select.h>
#include	<sys/socket.h>
#include	<errno.h>
#include	<pwd.h>
#include	<netdb.h>
#include	<netinet/in.h>
#include	"firewall.h"

#define	SOCKS4_REQUEST_VERSION	0x04
#define	SOCKS4_REPLY_VERSION	0x00
#define	SOCKS4_GRANTED		90
#define	SOCKS4_FAILED		91

#define	SOCKS5_REQUEST_VERSION	0x05
#define	SOCKS5_REPLY_VERSION	0x05
#define	SOCKS5_SUCCEEDED	0x00
#define	SOCKS5_FAILURE		0x01

#define SOCKS5_AUTH_NOAUTH	0x00
#define SOCKS5_AUTH_GSSAPI	0x01
#define SOCKS5_AUTH_PWD		0x02
#define SOCKS5_AUTH_BAD		0xFF

#define SOCKS5_AUTH_PWD_REQUEST_VER	0x01
#define SOCKS5_AUTH_PWD_REPLY_VER	0x01
#define SOCKS5_AUTH_PWD_REPLY_STATUS	0x01

#define SOCKS5_ATYP_INET	0x01
#define SOCKS5_ATYP_DOMAIN	0x03
#define SOCKS5_ATYP_INET6	0x04

#define	SOCKS_CONNECT		0x01
#define	SOCKS_BIND		0x02
#define	SOCKS_UDP		0x03

struct socks_auth {
	char	ver;
	char	username[256];
	char	password[256];
};

struct socks_request {
	char			ver;
	char			cmd;
	char			rsv;
	char			atyp;
	struct sockaddr_in	dst;
	struct socks_auth	auth;
	char			host[64];
	char			port[8];
};

struct socks_reply {
	char			ver;
	char			rep;
	char			rsv;
	char			atyp;
	struct sockaddr_in	bnd;
	char			host[64];
	char			port[8];
};


extern	int	timeout;
extern	char	service[];
extern	char	eaddr[];

int	socks_request();
int	socks_reply();
int	socks_read();
int	socks_readzs();
int	socks_write();
int	socks_writezs();
int	socks_listen();
int	socks_accept();
int	socks4_request();
int	socks4_reply();
int	socks5_request();
int	socks5_reply();

