/* socks4.c */

#include "socks-gw.h"

static	char	RcsId[] = "$Header: /usr/home/ygk/fwtk/socks-gw/RCS/socks4.c,v 1.1 2000/05/22 15:10:19 ygk Exp ygk $";

int socks4_request(s,req)
int	s;
struct socks_request *req;
{
	char	c;
	int	i;
	char	userid[128];

	if (socks_read(s, &(req->cmd), sizeof(req->cmd)))
		return(1);
	if (socks_read(s, &(req->dst.sin_port), sizeof(req->dst.sin_port)))
		return(1);
	if (socks_read(s, &(req->dst.sin_addr), sizeof(req->dst.sin_addr)))
		return(1);
	if (socks_readzs(s, userid, sizeof(userid)))
		return(1);

	req->dst.sin_family = AF_INET;
	strncpy(req->host, inet_ntoa(req->dst.sin_addr), sizeof(req->host));
	req->host[sizeof(req->host) - 1] = '\0';
	snprintf(req->port, sizeof(req->port), "%d", ntohs(req->dst.sin_port));
	req->port[sizeof(req->port) - 1] = '\0';
	return(0);
}

int socks4_reply(s,reply)
int	s;
struct socks_reply	*reply;
{
	char	buf[512];

	buf[0] = reply->ver;
	buf[1] = reply->rep;
	bcopy(buf + 2, &(reply->bnd.sin_port), sizeof(reply->bnd.sin_port));
	bcopy(buf + 2 + sizeof(reply->bnd.sin_port), &(reply->bnd.sin_addr), sizeof(reply->bnd.sin_addr));
	if (socks_write(0, buf, 2 + sizeof(reply->bnd.sin_port) + sizeof(reply->bnd.sin_addr)))
		return(1);
	return(0);
}

int socks_read(s,buf,z)
int	s;
char	*buf;
int	z;
{
	char		*p = buf;
	int		n, ret;
	fd_set		fds;
	struct timeval	timo;

	while(z > 0)
	{
		FD_ZERO(&fds);
		FD_SET(0, &fds);
		timo.tv_sec = timeout;
		timo.tv_usec = 0;
		if ((ret = select(1,&fds,NULL,NULL,&timo)) == 0)
			continue;
		if (ret < 0)
			if (errno == EINTR)
				continue;
			else
				return(1);
		if ((n = read(0, p, z)) > 0) {
			p += n;
			z -= n;
		} else if ((n < 0)&&((errno == EWOULDBLOCK) || (errno == EINTR)))
			continue;
		else
			return(1);
	}
	return(0);
}

int socks_write(s,buf,z)
int	s;
char	*buf;
int	z;
{
	char		*p = buf;
	int		n, ret;
	fd_set		fds;
	struct timeval	timo;

	while(z > 0)
	{
		FD_ZERO(&fds);
		FD_SET(0, &fds);
		timo.tv_sec = timeout;
		timo.tv_usec = 0;
		if ((ret = select(1,NULL,&fds,NULL,&timo)) == 0)
			continue;
		if (ret < 0)
			if (errno == EINTR)
				continue;
			else
				return(1);
		if ((n = write(0, p, z)) > 0) {
			p += n;
			z -= n;
		} else if ((n < 0)&&((errno == EWOULDBLOCK) || (errno == EINTR)))
			continue;
		else
			return(1);
	}
	return(0);
}

int socks_readzs(s,str,z)
int	s;
char	*str;
int	z;
{
	char	c;
	int	i = 0;
        while (!socks_read(s, &c, 1))
                if (c == '\0')
			break;
                else if (i < z - 1) 
                        str[i++] = c;
        str[i] = '\0';
	return(c);
}

int socks_writezs(s,str,z)
int	s;
char	*str;
int	z;
{
	char	c;
	int	i;

        for (i = 0; i < z; i++)
	{
		if (socks_write(s,str + i,1))
			return(1);
                if (str[i] == '\0')
			break;
	}
	return(0);
}

int socks_connect(reply)
struct socks_reply	*reply;
{
	int	sockfd;
	int	len;

	sockfd = socket(AF_INET,SOCK_STREAM,0);
	if (sockfd < 0) {
		syslog(LLEV,"socks_connect:socket failed, %m");
		return(-1);
	}
	if (connect(sockfd, (struct sockaddr *)&(reply->bnd), sizeof(reply->bnd)) < 0) {
		syslog(LLEV,"socks_connect:connect failed, %m");
		return(-1);
	}
	len = sizeof(reply->bnd);
	if (getsockname(sockfd, (struct sockaddr *)&(reply->bnd), &len) < 0) {
		syslog(LLEV,"socks_connect:getsockname failed, %m");
		return(-1);
	}
	strncpy(reply->host, inet_ntoa(reply->bnd.sin_addr), sizeof(reply->host));
	reply->host[sizeof(reply->host) - 1] = '\0';
	return(sockfd);
}

int socks_listen(reply)
struct socks_reply	*reply;
{
	int	sockfd;
	int	len;

	if (!inet_aton(eaddr, &(reply->bnd.sin_addr))) {
		syslog(LLEV,"socks_listen:inet_aton failed, %m");
		return(-1);
	}
	sockfd = socket(AF_INET,SOCK_STREAM,0);
	if (sockfd < 0) {
		syslog(LLEV,"socks_listen:socket failed, %m");
		return(-1);
	}
	if (bind(sockfd, (struct sockaddr *)&(reply->bnd), sizeof(reply->bnd)) < 0) {
		syslog(LLEV,"socks_listen:bind failed, %m");
		return(-1);
	}
	if (listen(sockfd,1) < 0) {
		syslog(LLEV,"socks_listen:listen failed, %m");
		return(-1);
	}
	len = sizeof(reply->bnd);
	if (getsockname(sockfd, (struct sockaddr *)&(reply->bnd), &len) < 0) {
		syslog(LLEV,"socks_listen:getsockname failed, %m");
		return(-1);
	}
	strncpy(reply->host, inet_ntoa(reply->bnd.sin_addr), sizeof(reply->host));
	reply->host[sizeof(reply->host) - 1] = '\0';
	return(sockfd);
}

int socks_accept(s, reply)
int	s;
struct socks_reply	*reply;
{
	int	sockfd, len;
	struct sockaddr_in	sa;

	len = sizeof(reply->bnd);
	if ((sockfd = accept(s, (struct sockaddr *)&(reply->bnd), &len)) < 0) {
		syslog(LLEV,"socks_accept:accept failed, %m");
		return(-1);
	}
	close(s);
	strncpy(reply->host, inet_ntoa(reply->bnd.sin_addr), sizeof(reply->host));
	reply->host[sizeof(reply->host) - 1] = '\0';
	return(sockfd);
}
