/* socks5.c */

#include "socks-gw.h"

static char	RcsId[] = "$Header: /usr/home/ygk/fwtk/socks-gw/RCS/socks5.c,v 1.1 2000/05/22 15:10:19 ygk Exp ygk $";

int socks5_auth(s, req)
int	s;
struct socks_request	*req;
{
	char	i;
	char	method[256];

	if(socks_read(s, &i, sizeof(i))) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	if(socks_read(s, method, i)) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	method[0] = SOCKS5_REPLY_VERSION;
	method[1] = SOCKS5_AUTH_NOAUTH;
	if(socks_write(s, method, 2)) {
		syslog(LLEV,"socks_write error,%m");
		return(1);
	}
	return(0);
}


int socks5_request(s, req)
int	s;
struct socks_request	*req;
{
	if(socks5_auth(s, req)) {
		syslog(LLEV,"socks5_auth error,%m");
		return(1);
	}
	if(socks_read(s, &(req->ver), sizeof(req->ver))) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	if(socks_read(s, &(req->cmd), sizeof(req->cmd))) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	if(socks_read(s, &(req->rsv), sizeof(req->rsv))) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	if(socks_read(s, &(req->atyp), sizeof(req->atyp))) {
		syslog(LLEV,"socks_read error,%m");
		return(1);
	}
	switch(req->atyp)
	{
	case SOCKS5_ATYP_INET:
		if(socks_read(s, &(req->dst.sin_addr), sizeof(req->dst.sin_addr))) {
			syslog(LLEV,"socks_read error,%m");
			return(1);
		}
		if(socks_read(s, &(req->dst.sin_port), sizeof(req->dst.sin_port))) {
			syslog(LLEV,"socks_read error,%m");
			return(1);
		}
		req->dst.sin_family = AF_INET;
	        strncpy(req->host, inet_ntoa(req->dst.sin_addr), sizeof(req->host));
       		req->host[sizeof(req->host) - 1] = '\0';
		snprintf(req->port, sizeof(req->port), "%d", ntohs(req->dst.sin_port));
		req->port[sizeof(req->port) - 1] = '\0';
		break;
	case SOCKS5_ATYP_DOMAIN:
	case SOCKS5_ATYP_INET6:
		return(1);
	}
	return(0);
}

int socks5_reply(s, reply)
int	s;
struct socks_reply	*reply;
{
	char	buf[512];

	buf[0] = reply->ver;
	buf[1] = reply->rep;
	buf[2] = reply->rsv;
	buf[3] = reply->atyp;
	if(reply->atyp == SOCKS5_ATYP_INET) {
		bcopy(buf + 4, &(reply->bnd.sin_port), sizeof(reply->bnd.sin_port));
		bcopy(buf + 4 + sizeof(reply->bnd.sin_port), &(reply->bnd.sin_addr), sizeof(reply->bnd.sin_addr));
		if (socks_write(0, buf, 4 + sizeof(reply->bnd.sin_port) + sizeof(reply->bnd.sin_addr)))
			return(1);
	} else {
		return(1);
	}
	return(0);
}
